/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Empresa;
import com.tabajara.base.tables.records.EmpresaRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class EmpresaDao extends AbstractVertxDAO<EmpresaRecord, com.tabajara.base.tables.pojos.Empresa, Integer, Future<List<com.tabajara.base.tables.pojos.Empresa>>, Future<com.tabajara.base.tables.pojos.Empresa>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<EmpresaRecord,com.tabajara.base.tables.pojos.Empresa,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public EmpresaDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Empresa.EMPRESA, com.tabajara.base.tables.pojos.Empresa.class, new JDBCClassicQueryExecutor<EmpresaRecord,com.tabajara.base.tables.pojos.Empresa,Integer>(com.tabajara.base.tables.pojos.Empresa.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Empresa object) {
        return object.getEmpid();
    }

    /**
     * Find records that have <code>empnome IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Empresa>> findManyByEmpnome(List<String> values) {
        return findManyByCondition(Empresa.EMPRESA.EMPNOME.in(values));
    }

    /**
     * Find records that have <code>empcnpj IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Empresa>> findManyByEmpcnpj(List<String> values) {
        return findManyByCondition(Empresa.EMPRESA.EMPCNPJ.in(values));
    }

    /**
     * Find records that have <code>emplocal IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Empresa>> findManyByEmplocal(List<String> values) {
        return findManyByCondition(Empresa.EMPRESA.EMPLOCAL.in(values));
    }
}
